# This is the script file, no need to edit this (Besides admin part). Edit the props.txt file!

Admins = ['STEAM_0:1:123456','STEAM_0:1:654321','STEAM_0:1:7589873'] # the admins
SayCommand = "!props" # command to open the menu

import es
import psyco
import vecmath
import popuplib
import playerlib
psyco.full()
CFGPath = str(es.getAddonPath("props")).replace("\\addons", "\\cfg").replace("/addons", "/cfg")
PropsFile = open(CFGPath + '/props.txt').readlines()
def load():
    SetUpProps()
    es.msg("#multi","#greenProps #default[#darkgreenV%s#default] #lightgreenhas been loaded" %(str(PubVar).lower().replace('cheetah-public','')))
def unload():
    es.msg("#multi","#greenProps #default[#darkgreenV%s#default] #lightgreenhas been unloaded" %(str(PubVar).lower().replace('cheetah-public','')))
def player_say(ev):
    if str(ev['text']).lower() == str(SayCommand).lower():
        for Admin in Admins:
            if str(ev['es_steamid']).lower() == str(Admin).lower():
                SendPopup(ev['userid'],'Props_Main')
                return
        es.tell(ev['userid'],'you haven\'t access to this!')
def es_map_start(ev): SetUpProps()
def PropsForThisPage(Number=0):
    global PropsForThisPageValue
    PropsForThisPageValue = int(Number)
def SendPopup(userid, popup, page=1):
    debugmsg = 0
    if debugmsg:
        es.msg("userid: %s" %(userid))
        es.msg("popup1: %s" %(popup))
        es.msg("page: %s" %(page))
    popup = popuplib.find(popup)
    if debugmsg: es.msg("popup2: %s" %(popup))
    if not isinstance(page, int):
        if debugmsg: es.msg("type != int, setting page to 1")
        page = 1
    popup.sendPage(userid, int(page))
def SpawnProp(userid,choice,popupname):
    CS = choice.split("--")
    SendPopup(userid,popupname,int(CS[0]))
    choice = CS[1]
    choice = choice.split(", ")
    SpawnProp2(str(userid),str(choice[3]),str(choice[6]),str(choice[4]),str(choice[5]))
def SpawnProp2(userid,name,path,type,radi):
    name = str(name).replace("'","")
    path = str(path).replace("'","")
    type = str(type).replace("'","")
    radi = str(radi).replace("'","")
    if str(type).lower() == 'physics':
        es.prop_physics_create(userid,path)
        PropLoc = playerlib.getPlayer(userid).getViewCoord()
    elif str(type).lower() == 'dynamic':
        es.prop_dynamic_create(userid,path)
        PropLoc = es.getindexprop(es.ServerVar("eventscripts_lastgive"), 'CBaseEntity.m_vecOrigin')
    else: return
    for CP in playerlib.getPlayerList('#alive'):
        if int(vecmath.distance(PropLoc,es.getplayerlocation(CP))) < int(radi):
            es.tell(userid, 'The prop is too close to the player %s' %(es.getplayername(CP)))
            es.remove(es.ServerVar("eventscripts_lastgive"))
def SetUpPropsMenu(category):
    temppropsmenu = popuplib.easymenu("Props_%s"%category,None,SpawnProp)
    temppropsmenu.settitle("- Props\n-- %s" %(category))
    PropsForThisPage()
    PropsInThisCategory = {}
    for props in PropsFile:
        propsS = props.split("|")
        if (len(propsS) == 8):
            if (propsS[2] == category):
                PropsInThisCategory[propsS[3]] = propsS
    for Prop in sorted(PropsInThisCategory.keys()):
        if len(PropsInThisCategory) < 10:
            Page = 1
        else:
            Page = PropsForThisPageValue / 7 + 1
            PropsForThisPage(PropsForThisPageValue+1)
        temppropsmenu.addoption("%s--%s" %(Page,PropsInThisCategory[Prop]),Prop)
    temppropsmenu.submenu(10,"Props_Main")
def SetUpProps():
    global PubVar
    PubVar = es.ServerVar("props_version","1.0CheeTaH-Public","Script Version")
    PubVar.set("1.0CheeTaH-Public")
    PubVar.makepublic()
    global Props_Main
    Props_Main = popuplib.easymenu('Props_Main',None, SendPopup)
    Props_Main.settitle("- Props")
    PropCategorys = {}
    for CurrentLine in PropsFile:
        if str(CurrentLine).lower().startswith('|add prop|'):
            SL = CurrentLine.split('|')
            if len(SL) == 8:
                if SL[2] not in PropCategorys: PropCategorys[SL[2]] = SL[2]
    for cat in sorted(PropCategorys.keys()):
        Props_Main.addoption("Props_%s" %(cat),cat)
        SetUpPropsMenu(cat)